 
      PROGRAM TDGEEV1
*
*         PDGEEV1
*
      include 'mpif.h'
*   -  
      INTEGER            LWORK, MAXN, LDA, MAXPROCS, NOUT, ILWORK
      DOUBLE PRECISION   ZERO, MONE
      PARAMETER          ( LDA = 20, LWORK = 231, MAXN = 100,
**      PARAMETER         ( LDA = 20, LWORK = -1, MAXN = 100,
     $                   MAXPROCS = 16, NOUT =6, ZERO = 0.0D+0,
     $                   MONE = -1.0D+0, ILWORK = 1 )
*
*  
      INTEGER            CTXT, I, IAM, INFO,
     $                   MYCOL, MYROW, N, NB, NPCOL, NPROCS, NPROW,
     $                   IA, JA
*
*  
      INTEGER            DESCA( 9 ), IWORK( ILWORK )
      DOUBLE PRECISION   A( LDA, LDA ),
     $                   WR(20), WI(20), WORK( LWORK ), WORK1( 7 )
**     $                   WORK( 60 ), WORK1( 7 )
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDMATINIT, PDLAPRNT,
     $                   PDGEEV1
*
*  
*
*  
*
      N = 20
      NB = 7
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
      IF( ( NPROCS.LT.1 ) ) THEN
         CALL BLACS_SETUP( IAM, NPROW*NPCOL )
      END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.EQ.-1 ) GO TO 20
*
*      A
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, LDA, INFO )
*
*   A
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
*   
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9992 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) '   '
*
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  A'
      END IF
 9985 FORMAT( / 9I5 /)
*
      CALL PDLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
*      A
*
      CALL PDGEEV1( N, A, IA, JA, DESCA, WR, WI, WORK, LWORK, INFO )
*
*  
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
**         WRITE( NOUT, FMT = 9999 ) WORK(1)
         WRITE( NOUT, FMT = 9991 ) WR, WI
**         WRITE( NOUT, FMT = * ) '  A'
      END IF
*
**      CALL PDLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
      CALL BLACS_GRIDEXIT( CTXT )
*
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( ' WORK(1) = ', D16.6,// )
 9991 FORMAT( ' WR '/, 20(D16.6/), / ' WI '/, 20(D16.6/), /)
*
 9992 FORMAT( / '   PDGEEV1' )
 9998 FORMAT( / '     A,'
     $      '  A -    ',
     $      I2, '  ', I2,',' /
     $       '         ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2 /)
 9996 FORMAT( / '  INFO  = ', I6 /)
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
* PDMATINIT     A   
*
*   - 
*  - 
      INTEGER            IA, INFO, JA, N
*  - 
      INTEGER            DESCA( * )
      DOUBLE PRECISION   A( * )
*  
      INTEGER            I, J
*
*  
      EXTERNAL           PDELSET
*
*  
*
      INFO = 0
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF( JA.NE.1 ) THEN
         INFO = -4
      END IF
*
      DO 2 J = 1, N
      DO 1 I = 1, N
      CALL PDELSET( A, I, J, DESCA, 0.0D0)
    1 CONTINUE
    2 CONTINUE
      DO 4 J = 1, N
      DO 3 I = 1, N
         IF( I.EQ.J ) THEN
            CALL PDELSET( A, I, J, DESCA, 1.0D0)
         END IF
    3 CONTINUE
    4 CONTINUE
      J = N
      DO 5 I = 1, N
      CALL PDELSET( A, I, J, DESCA, DBLE(I) )
    5 CONTINUE
      I = N
      DO 6 J = 1, N
      CALL PDELSET( A, I, J, DESCA, DBLE(J) )
    6 CONTINUE
*
      RETURN
*
*     End of PDMATINIT
*
      END
